现在的位置: 首页 > 综合 > 正文

hdu 1069 Monkey and Banana(简单dp)

2014年09月05日 ⁄ 综合 ⁄ 共 3019字 ⁄ 字号 评论关闭

Monkey and Banana

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 6406    Accepted Submission(s): 3270


Problem Description
A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana
by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions
of the base and the other dimension was the height. 

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly
smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

 


Input
The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.
 


Output
For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
 


Sample Input
1 10 20 30 2 6 8 10 5 5 5 7 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7 5 31 41 59 26 53 58 97 93 23 84 62 64 33 83 27 0
 


Sample Output
Case 1: maximum height = 40 Case 2: maximum height = 21 Case 3: maximum height = 28 Case 4: maximum height = 342
 
题目大意:主要是在读题目时花了不少时间,就是给你n组x,y,z,然后x,y,z可以任意组合形成一个长方体的长宽高,那么排列是有6种,然后我们可以将这6*n个长方体,选一些出来,使得立方体能够一个挨一个从下面往上摞在一起,如果a摞在b上面,那么需要ax<bx&&ay<by或者ax<by&&ay<bx,就是上面的可以摞在上面,然后求解这些长方体可以摞在一起的最大的高之和。

     解题思路:我们可以先选取一个作为高,然后把其它两个分别作为长和宽,我们如果规定长>=宽,那么每次扩张6种可以压缩成为3种。n最大为30,可以先对这3n个立方体排序然后动态规划即可。具体见代码。

     题目地址:Monkey and Banana

AC代码:
#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
using namespace std;

struct node
{
    int x;
    int y;
    int z;
}nod[105];

int dp[105];

int cmp(node a,node b)
{
    if(a.x<b.x) return 1;
    if(a.x==b.x&&a.y<b.y) return 1;
    return 0;
}

int main()
{
    int n,cas=1;
    while(cin>>n&&n>0)
    {
        int i,j,m=0;
        int a[3];
        for(i=0;i<n;i++)
        {
            cin>>a[0]>>a[1]>>a[2];     //每种有6种情况,但是由于x1<x2&&y1<y2可以缩减为3种情况
            nod[m].x=max(a[0],a[1]),nod[m].y=min(a[0],a[1]),nod[m++].z=a[2];
            nod[m].x=max(a[1],a[2]),nod[m].y=min(a[1],a[2]),nod[m++].z=a[0];
            nod[m].x=max(a[0],a[2]),nod[m].y=min(a[0],a[2]),nod[m++].z=a[1];
        }

        sort(nod,nod+m,cmp);
        for(i=0;i<m;i++)
        {
            int ma=0;
            for(j=0;j<i;j++)
            {
                if(nod[j].x<nod[i].x&&nod[j].y<nod[i].y)
                    ma=max(ma,dp[j]);
            }
            dp[i]=ma+nod[i].z;
        }

        int res=0;
        for(i=0;i<m;i++)
            res=max(res,dp[i]);

        printf("Case %d: maximum height = %d\n",cas++,res);
    }
    return 0;
}

/*
1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0
*/

抱歉!评论已关闭.